# Class VulkanPipelineLayoutCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineLayoutCreateInfo

All Implemented Interfaces:
  `VulkanPipelineLayoutCreateInfoType`

public final class VulkanPipelineLayoutCreateInfo extends Object implements VulkanPipelineLayoutCreateInfoType

See Also:
  - "VkPipelineLayoutCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanPipelineLayoutCreateInfo.Builder`
  Builds instances of type `VulkanPipelineLayoutCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanPipelineLayoutCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanPipelineLayoutCreateInfo`.
  `static VulkanPipelineLayoutCreateInfo`
  `copyOf(VulkanPipelineLayoutCreateInfoType instance)`
  Creates an immutable copy of a `VulkanPipelineLayoutCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanPipelineLayoutCreateInfo` that have equal attribute values.
  `Set<VulkanPipelineLayoutCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `setLayouts`, `pushConstantRanges`.
  `static VulkanPipelineLayoutCreateInfo`
  `of(Iterable<VulkanPipelineLayoutCreateFlag> flags, Iterable<? extends VulkanDescriptorSetLayoutType> setLayouts, Iterable<? extends VulkanPushConstantRange> pushConstantRanges)`
  Construct a new immutable `VulkanPipelineLayoutCreateInfo` instance.
  `static VulkanPipelineLayoutCreateInfo`
  `of(Set<VulkanPipelineLayoutCreateFlag> flags, List<VulkanDescriptorSetLayoutType> setLayouts, List<VulkanPushConstantRange> pushConstantRanges)`
  Construct a new immutable `VulkanPipelineLayoutCreateInfo` instance.
  `List<VulkanPushConstantRange>`
  `pushConstantRanges()`
  `List<VulkanDescriptorSetLayoutType>`
  `setLayouts()`
  `String`
  `toString()`
  Prints the immutable value `VulkanPipelineLayoutCreateInfo` with attribute values.
  `final VulkanPipelineLayoutCreateInfo`
  `withFlags(VulkanPipelineLayoutCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineLayoutCreateInfo`
  `withFlags(Iterable<VulkanPipelineLayoutCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineLayoutCreateInfo`
  `withPushConstantRanges(VulkanPushConstantRange... elements)`
  Copy the current immutable object with elements that replace the content of `pushConstantRanges`.
  `final VulkanPipelineLayoutCreateInfo`
  `withPushConstantRanges(Iterable<? extends VulkanPushConstantRange> elements)`
  Copy the current immutable object with elements that replace the content of `pushConstantRanges`.
  `final VulkanPipelineLayoutCreateInfo`
  `withSetLayouts(VulkanDescriptorSetLayoutType... elements)`
  Copy the current immutable object with elements that replace the content of `setLayouts`.
  `final VulkanPipelineLayoutCreateInfo`
  `withSetLayouts(Iterable<? extends VulkanDescriptorSetLayoutType> elements)`
  Copy the current immutable object with elements that replace the content of `setLayouts`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanPipelineLayoutCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanPipelineLayoutCreateInfoType`
    Returns:
      Creation flags

  - ### setLayouts

    public List<VulkanDescriptorSetLayoutType> setLayouts()
    Specified by:
      `setLayouts` in interface `VulkanPipelineLayoutCreateInfoType`
    Returns:
      A list of descriptor set layouts

  - ### pushConstantRanges

    public List<VulkanPushConstantRange> pushConstantRanges()
    Specified by:
      `pushConstantRanges` in interface `VulkanPipelineLayoutCreateInfoType`
    Returns:
      A list of push constant ranges

  - ### withFlags

    public final VulkanPipelineLayoutCreateInfo withFlags(VulkanPipelineLayoutCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanPipelineLayoutCreateInfo withFlags(Iterable<VulkanPipelineLayoutCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withSetLayouts

    public final VulkanPipelineLayoutCreateInfo withSetLayouts(VulkanDescriptorSetLayoutType... elements)
    Copy the current immutable object with elements that replace the content of `setLayouts`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withSetLayouts

    public final VulkanPipelineLayoutCreateInfo withSetLayouts(Iterable<? extends VulkanDescriptorSetLayoutType> elements)
    Copy the current immutable object with elements that replace the content of `setLayouts`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of setLayouts elements to set
    Returns:
      A modified copy of `this` object

  - ### withPushConstantRanges

    public final VulkanPipelineLayoutCreateInfo withPushConstantRanges(VulkanPushConstantRange... elements)
    Copy the current immutable object with elements that replace the content of `pushConstantRanges`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withPushConstantRanges

    public final VulkanPipelineLayoutCreateInfo withPushConstantRanges(Iterable<? extends VulkanPushConstantRange> elements)
    Copy the current immutable object with elements that replace the content of `pushConstantRanges`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of pushConstantRanges elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanPipelineLayoutCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `setLayouts`, `pushConstantRanges`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanPipelineLayoutCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanPipelineLayoutCreateInfo of(Set<VulkanPipelineLayoutCreateFlag> flags, List<VulkanDescriptorSetLayoutType> setLayouts, List<VulkanPushConstantRange> pushConstantRanges)
    Construct a new immutable `VulkanPipelineLayoutCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `setLayouts` - The value for the `setLayouts` attribute
      `pushConstantRanges` - The value for the `pushConstantRanges` attribute
    Returns:
      An immutable VulkanPipelineLayoutCreateInfo instance

  - ### of

    public static VulkanPipelineLayoutCreateInfo of(Iterable<VulkanPipelineLayoutCreateFlag> flags, Iterable<? extends VulkanDescriptorSetLayoutType> setLayouts, Iterable<? extends VulkanPushConstantRange> pushConstantRanges)
    Construct a new immutable `VulkanPipelineLayoutCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `setLayouts` - The value for the `setLayouts` attribute
      `pushConstantRanges` - The value for the `pushConstantRanges` attribute
    Returns:
      An immutable VulkanPipelineLayoutCreateInfo instance

  - ### copyOf

    public static VulkanPipelineLayoutCreateInfo copyOf(VulkanPipelineLayoutCreateInfoType instance)
    Creates an immutable copy of a `VulkanPipelineLayoutCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanPipelineLayoutCreateInfo instance

  - ### builder

    public static VulkanPipelineLayoutCreateInfo.Builder builder()
    Creates a builder for `VulkanPipelineLayoutCreateInfo`.

         VulkanPipelineLayoutCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanPipelineLayoutCreateFlag) // flags elements
            .addSetLayouts|addAllSetLayouts(com.io7m.jcoronado.api.VulkanDescriptorSetLayoutType) // setLayouts elements
            .addPushConstantRanges|addAllPushConstantRanges(VulkanPushConstantRange) // pushConstantRanges elements
            .build();

    Returns:
      A new VulkanPipelineLayoutCreateInfo builder